//SETA43 22/04/2015
// 
// A/D  ->  D/A
// Grabador reproductor de audio
// 

#include <SD.h>
File dataFile;

#include <EEPROM.h>

unsigned int nfichero;
char namefichero[15];


String inputString = "";  
char fileplay[20] ;
boolean stringComplete = false;  

#define MAXBUFFER  300
#define MAXBUFFER1 299  //#define MAXBUFFER menos 1

#define ledGrabar 2
#define ledReproducir 3


byte valor;
byte bufer0[MAXBUFFER];
byte bufer1[MAXBUFFER];
int din=0;
int dout=0;
byte nf=0;
byte vacio=1;
byte fin=1;
byte atras=0;

int z;
byte modo; 
byte z1;
//0=pasa entrada a salida directamente
//1=reproduce
//2=graba

void setup()
{
  pinMode(ledGrabar, OUTPUT);
  pinMode(ledReproducir, OUTPUT);
  digitalWrite(ledGrabar, HIGH);
  digitalWrite(ledReproducir, HIGH);
  
  Serial.begin(9600);  
  inputString.reserve(50);
  
  pinMode(9, OUTPUT);  //Salida audio
   
  pinMode(4, INPUT);  //Botones 
  pinMode(5, INPUT);
  pinMode(6, INPUT);
 
 // pinMode(4, OUTPUT);    // si utilizamos la salida 4 como CS de la tarjeta SD
 // if(!SD.begin(4)){    //  
   pinMode(10, OUTPUT);    // si utilizamos la salida 4 como CS de la tarjeta SD
  if(!SD.begin(10)) 
  {
    Serial.println("Tarjeta erronea o no insertada");    // Texto informativo
    return;
  }
  else
  {
    Serial.println("Tarjeta OK");    // Texto informativo
  }
  
  //_______________________a/d  fast__________
  bitWrite(ADCSRA,ADPS2,1);
  bitWrite(ADCSRA,ADPS1,0);
  bitWrite(ADCSRA,ADPS0,0); 
  //Analog Input A0
  ADMUX=(1<<ADLAR)|(0<<REFS1)|(1<<REFS0)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0);
  //__________________________________________
  

  
  cli();//stop interrupts
  TCCR1A = 0x81;
  TCCR1B = 0x01;
  OCR1A = 255;
  TIMSK1=0;
  //timer interrupts
  //by Amanda Ghassaei
  //set timer2 interrupt at 11kHz
  TCCR2A = 0;// set entire TCCR2A register to 0
  TCCR2B = 0;// same for TCCR2B
  TCNT2  = 0;//initialize counter value to 0
  OCR2A = 182;// = (16*10^6) / (11000*8) - 1 (must be <256)  11khz
  // turn on CTC mode
  TCCR2A |= (1 << WGM21);
  // Set CS21 bit for 8 prescaler
  TCCR2B |= (1 << CS21);      
  // enable timer compare interrupt
  TIMSK2 |= (1 << OCIE2A);
  delay(500);
  sei();//allow interrupts

  ClearBuffer(); 
  modo=0;
  delay(500);
}


ISR(TIMER2_COMPA_vect)
{ 
   //timer1 interrupt 11kHz toggles 
  switch (modo)
       {
        case 0:  //pase
//         valor=analogReadFast();  
//          OCR1AH = 0; 
//          OCR1AL = valor;     
//          OCR1AL = 128;
            ;
         break; 
        case 1: //reproduce
          if(nf==0)
            valor=bufer1[dout];
           else
            valor=bufer0[dout];
          dout++;
          if(dout>MAXBUFFER1)
              {
               vacio=1;
               dout=0;
               if(nf==1)
                 nf=0;
                else
                 nf=1;       
              }  
          OCR1AH = 0; 
          OCR1AL = valor;               
         break;         
        case 2://graba
         valor=analogReadFast();
//          OCR1AH = 0; 
 //         OCR1AL = valor;              
         if(nf==0)
            bufer1[dout]=valor;
           else
            bufer0[dout]=valor;
          dout++;
          if(dout>MAXBUFFER1)
              {
               vacio=1;
               dout=0;
               if(nf==1)
                 nf=0;
                else
                 nf=1;       
              }                     
         break;         
       }  
}

void loop()
{
  
  if(fin == 1)
           {
            digitalWrite(ledGrabar, LOW);
            digitalWrite(ledReproducir, LOW); 
           }

/*
  if(digitalRead(4))Serial.println("Boton4");
  if(digitalRead(5))Serial.println("Boton5");
  if(digitalRead(6))Serial.println("Boton6");
*/    
  
                
  switch (modo)
       {
         case 0:  //paso
               if(digitalRead(5))  //Boton reproducir
                { 
                  getName();                 
                  strcpy(fileplay,namefichero);
                  stringComplete = true;
                  modo=1;  
                  while(digitalRead(5));                
                }
               if(digitalRead(6))    //Boton grabar
                {     
                  newName();
                  strcpy(fileplay,namefichero);
                  stringComplete = true;
                  modo=2;  
                  while(digitalRead(6));                
                }           
         break; 
//_________________________________________________________         
         case 1: //reproduce
              if(digitalRead(4) || digitalRead(6) )
                {
                  strcpy(fileplay,"stop");
                  stringComplete = true;
                  modo=0;
                  atras=0;
                  Serial.println("Modo=0");
                }
              if(digitalRead(5) )  //Cancion anterior
                {
                  while(digitalRead(5))delay(300);
                  atras++;
                  getName();       
                  sprintf(namefichero,"%05d.wav",nfichero-atras);
                  Serial.print(namefichero);  Serial.println(" <<");                 
                  strcpy(fileplay,namefichero);
                  stringComplete = true;                  
                }
              if(vacio == 1 && fin == 0)
                {     
                 if(nf==0) for(din=0;din<MAXBUFFER;din++) bufer0[din] = dataFile.read();
                 if(nf==1) for(din=0;din<MAXBUFFER;din++) bufer1[din] = dataFile.read();
                 vacio=0;
                 if(!dataFile.available())
                     {
                       Serial.println("Fin de cancion");
                       ClearBuffer();
                       fin=1;
                       modo=0;
                       atras=0;
                     }
               }     
              if (stringComplete) 
                  {
                   if(strcmp(fileplay, "stop")  == 0)
                     {
                       Serial.println("Stop reproduccion");
                       ClearBuffer();
                       dataFile.close();
                       fin=1;         
                     }
                    else
                     {        
                      dataFile.close();
                      dataFile = SD.open(fileplay,FILE_READ);
                      if (dataFile) 
                        {
                         Serial.print("OK ");
                         for(din=0;din<1000;din++) dataFile.read(); //quita 1000 bytes del wav
                         fin=0;
                         digitalWrite(ledReproducir, HIGH);
                        }
                        else
                        {
                         Serial.print("Error "); 
                        }
                        Serial.println(fileplay);
                     }      
                  inputString = "";
                  stringComplete = false;
                 }            
         break; 
 //_________________________________________________________        
         case 2://graba
           if(digitalRead(4) || digitalRead(5) )
                {
                  strcpy(fileplay,"stop");
                  stringComplete = true;
                  modo=0;
                  Serial.println("Modo=0");
                }
           if(vacio == 1 && fin == 0)
                {     
                 if(nf==0) dataFile.write(bufer0,MAXBUFFER);
                 if(nf==1) dataFile.write(bufer1,MAXBUFFER);
                 vacio=0;                 
               }          
         
           if (stringComplete) 
            {    
             if(strcmp(fileplay, "stop")  == 0)
             {               
               Serial.println("Stop grabacion");               
               dataFile.close();
               ClearBuffer();               
               fin=1;
               modo=0;
             }
           else
             {        
              dataFile.close();
              dataFile = SD.open(fileplay,FILE_WRITE);
              if (dataFile) 
                {
                 z1=0;
                 Serial.print("OK para WRITE ");
                 for(din=0;din<1000;din++) dataFile.write(z1); //quita 1000 bytes del wav
                 fin=0;
                 digitalWrite(ledGrabar, HIGH);
                }
              else
                {
                 Serial.print("Error "); 
                }
              Serial.println(fileplay);
             }      
            inputString = "";
            stringComplete = false;
           }                     
           break;         
       }      
}

void serialEvent() 
{
 int z;
  while (Serial.available()) 
   {
    char inChar = (char)Serial.read(); 
    inputString += inChar;
    if (inChar == '\n')  
       {
         inputString.toCharArray(fileplay,19);
         for(z=inputString.length();z>=0 && z<19;z--) if(fileplay[z]<30) fileplay[z]=0;
         
         if(!strcmp(fileplay,""))
            {
             inputString="";
             Serial.println("No input");             
             goto salir1;
            }
         if(!strcmp(fileplay,"modo=0"))
            {
             modo=0;
             ClearBuffer();
             inputString=""; 
             Serial.println("Modo=paso");             
             goto salir1;
            }
         if(!strcmp(fileplay,"modo=1"))
            {
             modo=1;
             ClearBuffer();
             inputString="";                    
             Serial.println("Modo=reproductor");            
             goto salir1;
            }
         if(!strcmp(fileplay,"modo=2"))
            {
             modo=2;
             ClearBuffer();
             inputString="";                    
             Serial.println("Modo=grabador");             
             goto salir1;
            }
         stringComplete = true;
salir1:         
      ;
       }
   }
}


//vacia bufer
void ClearBuffer()
{
  for(din=0;din<MAXBUFFER;din++){ bufer0[din]=128;  bufer1[din]=128;}    
}

 //Read ADC
int analogReadFast()
{
 ADCSRA|=(1<<ADSC);
 // ADSC is cleared when the conversion finishes
 while (bit_is_set(ADCSRA, ADSC));
        return ADCH;
}


//Funciones de toma de nombre mediante dato de la EPROM
void getName()
{ 
  nfichero=EEPROM.read(1);  nfichero =nfichero<<8;  nfichero+=EEPROM.read(0);  
  sprintf(namefichero,"%05d.wav",nfichero);
  Serial.println(namefichero);
}

void newName()
{
 byte value1;
 byte value0;
  nfichero=EEPROM.read(1);  nfichero =nfichero<<8;  nfichero+=EEPROM.read(0);  
  nfichero++;
  value0=nfichero & 0x00FF; value1=nfichero>>8;
  EEPROM.write(0, value0);   EEPROM.write(1, value1);
  sprintf(namefichero,"%05d.wav",nfichero);
  Serial.println(namefichero);
}
